> ## Documentation Index
> Fetch the complete documentation index at: https://composio-preview.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Better Stack

> Better Stack provides monitoring, logging, and incident management solutions to help teams ensure the reliability and performance of their applications.

![Better Stack logo](https://mintcdn.com/composio-preview/6S5R4NszqpnVIZRD/images/toolkits/better_stack.svg?fit=max\&auto=format\&n=6S5R4NszqpnVIZRD\&q=85\&s=7cd844450a2b11886a3b1dfe0ceed878)

* **Category:** server monitoring
* **Auth:** API\_KEY
* **Composio-managed OAuth available?** N/A
* **Tools:** 117
* **Triggers:** 0
* **Slug:** `BETTER_STACK`
* **Version:** 20261101\_00

## Tools

> [accordion] Acknowledge Incident
>
> **Slug:** `BETTER_STACK_ACKNOWLEDGE_INCIDENT`
>
> Tool to acknowledge an ongoing incident. Use when you need to mark an incident as being worked on, which prevents further escalations. Acknowledging an incident signals that someone is actively addressing the issue.
>
> #### Input Parameters
>
> **incident\_id** `string` *required*
>
> The ID of the incident to acknowledge
>
> **acknowledged\_by** `string`
>
> Email or custom identifier of the person or system acknowledging the incident
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Batch create catalog records
>
> **Slug:** `BETTER_STACK_BATCH_CREATE_CATALOG_RECORDS`
>
> ##### Batch create catalog records Allows creation of multiple Catalog records at once. POST /api/v2/catalog/relations/\{relation\_id}/records/batch Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **records** `array` *required*
>
> Records sent as a raw JSON array. Each record contains an attributes array; entries contain attribute (id/name) and values (typed value or item\_id objects). Follows the single Catalog record creation format.
>
> **relation\_id** `string` *required*
>
> The ID of the Catalog relation you want to create records for.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Batch remove catalog records
>
> **Slug:** `BETTER_STACK_BATCH_REMOVE_CATALOG_RECORDS`
>
> ##### Batch remove catalog records Permanently deletes **all** existing Catalog records for a given relation. DELETE /api/v2/catalog/relations/\{relation\_id}/records/batch Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **relation\_id** `string` *required*
>
> The ID of the Catalog relation you want to delete records for.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Batch update catalog records
>
> **Slug:** `BETTER_STACK_BATCH_UPDATE_CATALOG_RECORDS`
>
> ##### Batch update catalog records Allows replacing **all** Catalog records for a given relation at once. This is a destructive operation and will remove all existing records for the relation before creating new ones. PUT /api/v2/catalog/relations/\{relation\_id}/records/batch Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **records** `array` *required*
>
> Array of records to be created. Each individual records follows the format for [creating a single Catalog record](https://betterstack.com/docs/uptime/api/create-catalog-record/).
>
> **relation\_id** `string` *required*
>
> The ID of the Catalog relation you want to replace records for.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Batch upsert catalog records
>
> **Slug:** `BETTER_STACK_BATCH_UPSERT_CATALOG_RECORDS`
>
> Create or partially update Catalog records in one atomic batch. Matches existing records by primary attribute values, regardless of value order; an empty primary attribute matches only an empty one. Matching records update only supplied attributes: omitted attributes retain their values, and an empty values array clears an attribute. Nonmatching inputs create records; existing records not matched by the batch remain unchanged. If any record cannot be saved, none are saved, including ambiguous matches or duplicate primary values within the batch. Returns records in input order and created/updated IDs. Requires a Better Stack Incidents API token with access to the relation.
>
> #### Input Parameters
>
> **records** `array` *required*
>
> Records to create or update. Each record contains an attributes array of objects with attribute (id and/or name) and values. Values contain type and type-specific fields, such as value for String or email for User. Omitted attributes keep their values; an empty values array clears an attribute.
>
> **relation\_id** `string` *required*
>
> The ID of the Catalog relation you want to create or update records for.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Bulk update on-call events
>
> **Slug:** `BETTER_STACK_BULK_UPDATE_ON_CALL_EVENTS`
>
> ##### Bulk update on-call schedule events Replace all current and future on-call events in a single on-call schedule: - Delete all events that start today at 0:00 UTC or later. - Create new events. All newly created events also must start today at 0:00 UTC or later. PUT /api/v2/on-calls/\{schedule\_id}/events Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **events** `array` *required*
>
> Events to create, each containing users (array of email addresses), starts\_at and ends\_at (ISO 8601 timestamps), and optional override (boolean). Replaces all events starting today at 00:00 UTC or later; new events must also start at or after that cutoff. Earlier events remain unchanged. Use the single-event structure: [https://betterstack.com/docs/uptime/api/create-on-call-calendar-event/](https://betterstack.com/docs/uptime/api/create-on-call-calendar-event/).
>
> **schedule\_id** `string` *required*
>
> The ID of the on-call schedule you want to replace events for. Use `default` to refer to the default on-call schedule for the team.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Amazon SNS integration
>
> **Slug:** `BETTER_STACK_CREATE_AMAZON_SNS_INTEGRATION`
>
> ##### Create Amazon SNS integration Returns either a newly created Amazon SNS integration, or validation errors. Subscribe a topic to the returned `url` to start receiving notifications, as described in the [Amazon SNS integration guide](https://betterstack.com/docs/uptime/integrations/integrating-with-better-uptime/amazon-sns/). Leave **Enable raw message delivery** off on that subscription, or every notification is rejected with `400`. POST /api/v2/amazon-sns Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Send an SMS to the on-call person.
>
> **call** `boolean`
>
> Call the on-call person.
>
> **name** `string`
>
> The name of the Amazon SNS integration that you can see in the dashboard.
>
> **push** `boolean`
>
> Send a push notification to the on-call person.
>
> **email** `boolean`
>
> Send an e-mail to the on-call person.
>
> **paused** `boolean`
>
> Set to `true` to pause the integration, `false` to unpause it.
>
> **policy\_id** `string`
>
> ID of the escalation policy for incidents from this integration. Without one, incidents alert the current on-call person through the channels set by `call`, `sms`, `email`, and `push`.
>
> **team\_name** `string`
>
> Required if using [global API token](https://betterstack.com/docs/uptime/api/getting-started-with-uptime-api/#get-a-global-api-token) to specify the team which should own the resource
>
> **team\_wait** `integer`
>
> How long we wait before escalating the incident to the team. In seconds. Send `null` to never escalate to the team, or `0` to alert the whole team right away.
>
> **cause\_field** `object`
>
> Incident cause extraction object; defaults to the whole message. Required string keys: field\_target (sns\_envelope, body, json, xml, query\_string, header) and match\_type (match\_everything, match\_before, match\_after, match\_between, match\_regex). target\_field: dot path for json/query\_string, header name, XML CSS selector, or TopicArn/MessageId/Subject for sns\_envelope; unused for body. body/json/xml read the published message; query\_string/header read AWS's HTTPS request, not the message. match\_everything takes the whole value. match\_before/match\_after require string content and extract text before/after it. match\_regex requires a regex in content and extracts its match or capture group. match\_between requires string content\_before and content\_after delimiters.
>
> **title\_field** `object`
>
> How to extract a custom incident title, as a field object with the same keys as `cause_field`. Defaults to the notification's `Subject`, and `null` removes it to use the default title.
>
> **started\_rules** `array`
>
> The conditions `started_rule_type` checks, as an array of rule objects with the keys below. At least one rule is required when the type is `any` or `all`. Nested fields: started\_rules\[].rule\_target: Which part of the notification the rule checks: `sns_envelope` for the envelope, `body`, `json`, or `xml` for the message your publisher sent, or `query_string` or `header` for AWS's own HTTPS request, which never contains your message.; started\_rules\[].target\_field: Which value to read: a dot-separated path such as `alert.id` for `json` and `query_string`, a header name for `header`, a CSS selector for `xml`, or `TopicArn`, `MessageId`, or `Subject` for `sns_envelope`. Not used with `body`.; started\_rules\[].match\_type: How to compare the value with `content`: `contains`, `contains_not`, `equals`, `equals_not`, `matches_regex`, or `matches_regex_not`.; started\_rules\[].content: The value to compare with. Must be a valid regular expression for `matches_regex` and `matches_regex_not`.
>
> **critical\_alert** `boolean`
>
> Send a critical push notification that ignores the mute switch and Do Not Disturb mode.
>
> **resolved\_rules** `array`
>
> The conditions `resolved_rule_type` checks, as rule objects with the same keys as `started_rules`.
>
> **recovery\_period** `integer ("0" | "60" | "180" | "300" | "900" | "1800" | "3600" | "7200")`
>
> How long to wait after a notification matching `resolved_rules` arrives before marking an incident as resolved, in seconds: `0`, `60`, `180`, `300`, `900`, `1800`, `3600`, or `7200`. Has no effect while `resolved_rule_type` is `unused`.
>
> **started\_rule\_type** `string ("unused" | "any" | "all")`
>
> When notifications start an incident: `unused` always, `any` when at least one of `started_rules` matches, or `all` when all of them match. Defaults to `unused`.
>
> **acknowledged\_rules** `array`
>
> The conditions `acknowledged_rule_type` checks, as rule objects with the same keys as `started_rules`.
>
> **resolved\_rule\_type** `string ("unused" | "any" | "all")`
>
> When notifications resolve an incident: `unused` never, `any` when at least one of `resolved_rules` matches, or `all` when all of them match. Defaults to `unused`, and any other value requires `started_alert_id_field` and `resolved_alert_id_field`.
>
> **other\_started\_fields** `array`
>
> Extra values to extract when an incident starts, saved as incident metadata. Each field object has the same keys as `cause_field`, plus `name`. Nested fields: other\_started\_fields\[].name: The metadata key to save the extracted value under. Must be unique within the array.
>
> **other\_resolved\_fields** `array`
>
> Extra values to extract when an incident is resolved, with the same keys as `other_started_fields`.
>
> **acknowledged\_rule\_type** `string ("unused" | "any" | "all")`
>
> When notifications acknowledge an incident: `unused` never, `any` when at least one of `acknowledged_rules` matches, or `all` when all of them match. Defaults to `unused`, and any other value requires `started_alert_id_field` and `acknowledged_alert_id_field`.
>
> **started\_alert\_id\_field** `object`
>
> How to extract the alert ID from the notification that starts an incident, with the same keys as `cause_field`; later notifications acknowledge and resolve the incident by matching it. Required when `acknowledged_rule_type` or `resolved_rule_type` isn't `unused`, and defaults to the whole message.
>
> **resolved\_alert\_id\_field** `object`
>
> How to extract the alert ID from a notification that resolves an incident, with the same keys as `cause_field`. Required when `resolved_rule_type` isn't `unused`.
>
> **other\_acknowledged\_fields** `array`
>
> Extra values to extract when an incident is acknowledged, with the same keys as `other_started_fields`.
>
> **acknowledged\_alert\_id\_field** `object`
>
> How to extract the alert ID from a notification that acknowledges an incident, with the same keys as `cause_field`. Required when `acknowledged_rule_type` isn't `unused`.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create AWS CloudWatch integration
>
> **Slug:** `BETTER_STACK_CREATE_AWS_CLOUDWATCH_INTEGRATION`
>
> ##### Create AWS CloudWatch integration Returns either a newly created AWS CloudWatch integration, or validation errors. POST /api/v2/aws-cloudwatch-integrations Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Send an SMS to the on-call person.
>
> **call** `boolean`
>
> Call the on-call person.
>
> **name** `string`
>
> The name of the AWS CloudWatch integration that you can see in the dashboard.
>
> **push** `boolean`
>
> Send a push notification to the on-call person.
>
> **email** `boolean`
>
> Send an e-mail to the on-call person.
>
> **paused** `boolean`
>
> Set to `true` to pause the integration, `false` to unpause it.
>
> **policy\_id** `string`
>
> ID of the escalation policy associated with the AWS CloudWatch integration.
>
> **team\_name** `string`
>
> Required if using [global API token](https://betterstack.com/docs/uptime/api/getting-started-with-uptime-api/#get-a-global-api-token) to specify the team which should own the resource
>
> **team\_wait** `integer`
>
> How long we wait before escalating the incident alert to the team. In seconds.
>
> **critical\_alert** `boolean`
>
> Send a critical push notification that ignores the mute switch and Do not Disturb mode.
>
> **recovery\_period** `integer`
>
> Has no effect for this integration, since an incident resolves as soon as AWS CloudWatch reports the alert as resolved.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create aws log group subscription
>
> **Slug:** `BETTER_STACK_CREATE_AWS_LOG_GROUP_SUBSCRIPTION`
>
> Create an override to subscribe or unsubscribe one CloudWatch log group. Requires an `aws` source with an AWS account already connected and a Telemetry API token with access to the source. Set subscribed to true to ingest the log group or false to skip it, overriding the source's automatic subscription setting. An override can be created before discovery of the log group; creating a duplicate region/name override returns HTTP 422.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> Name of the CloudWatch log group, for example `/aws/lambda/checkout`.
>
> **region** `string` *required*
>
> AWS region of the log group, for example `us-east-1`.
>
> **source\_id** `string` *required*
>
> ID of an `aws` source with an AWS account already connected.
>
> **subscribed** `boolean` *required*
>
> Whether to ingest this log group. Set to `true` to subscribe or `false` to skip it.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Azure integration
>
> **Slug:** `BETTER_STACK_CREATE_AZURE_INTEGRATION`
>
> ##### Create Azure integration Returns either a newly created Azure integration, or validation errors. POST /api/v2/azure-integrations Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Send an SMS to the on-call person.
>
> **call** `boolean`
>
> Call the on-call person.
>
> **name** `string`
>
> The name of the Azure integration that you can see in the dashboard.
>
> **push** `boolean`
>
> Send a push notification to the on-call person.
>
> **email** `boolean`
>
> Send an e-mail to the on-call person.
>
> **paused** `boolean`
>
> Set to `true` to pause the integration, `false` to unpause it.
>
> **policy\_id** `string`
>
> ID of the escalation policy associated with the Azure integration.
>
> **team\_name** `string`
>
> Required if using [global API token](https://betterstack.com/docs/uptime/api/getting-started-with-uptime-api/#get-a-global-api-token) to specify the team which should own the resource
>
> **team\_wait** `integer`
>
> How long we wait before escalating the incident alert to the team. In seconds.
>
> **critical\_alert** `boolean`
>
> Send a critical push notification that ignores the mute switch and Do not Disturb mode.
>
> **recovery\_period** `integer`
>
> Has no effect for this integration, since an incident resolves as soon as Azure reports the alert as resolved.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create catalog attribute
>
> **Slug:** `BETTER_STACK_CREATE_CATALOG_ATTRIBUTE`
>
> ##### Create catalog attribute Returns either a newly created Catalog attribute, or validation errors. POST /api/v2/catalog/relations/\{relation\_id}/attributes Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> The name of the Catalog attribute.
>
> **primary** `boolean`
>
> Whether this is a primary attribute. Primary attributes are matched against the incident metadata key of the same name, the other attributes are added to matching incidents as metadata. Defaults to `false`.
>
> **position** `integer`
>
> The position of the attribute in the Catalog relation, lower values first. Defaults to `0`.
>
> **relation\_id** `string` *required*
>
> The ID of the Catalog relation you want to create an attribute for.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create catalog record
>
> **Slug:** `BETTER_STACK_CREATE_CATALOG_RECORD`
>
> ##### Create catalog record Returns either a newly created Catalog record, or validation errors. POST /api/v2/catalog/relations/\{relation\_id}/records Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **attributes** `array` *required*
>
> Record attributes: \[\{attribute: \{id or name}, values: \[\{type, value or item\_id/name/email}]}]. Attribute id/name and value identifiers are strings. Each value requires type: String, User, Team, Policy, Schedule, Endpoint, Source, SlackIntegration, LinearIntegration, JiraIntegration, MicrosoftTeamsWebhook, ZapierWebhook, NativeWebhook, or PagerDutyWebhook. String requires value. References require item\_id, name, or email (email for User); Endpoint references a monitor ID. Endpoint, SlackIntegration and ZapierWebhook cannot be referenced by name. Multiple values per attribute are supported.
>
> **relation\_id** `string` *required*
>
> The ID of the Catalog relation you want to create a record for.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create catalog relation
>
> **Slug:** `BETTER_STACK_CREATE_CATALOG_RELATION`
>
> ##### Create catalog relation Returns either a newly created Catalog relation, or validation errors. POST /api/v2/catalog/relations Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> The name of the Catalog relation.
>
> **match\_mode** `string ("any" | "all")`
>
> `any`, the default, applies a record when at least one of its primary attribute values matches the incident's metadata. `all` applies it only when every primary attribute value matches, with an empty value matching anything.
>
> **description** `string`
>
> A description of the Catalog relation.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create chart
>
> **Slug:** `BETTER_STACK_CREATE_CHART`
>
> Create a chart on a specific dashboard. Requires a Telemetry API token. Only line\_chart supports multiple queries. funnel\_chart cannot be created through the API. For SQL queries, filter dt with \{\{start\_time}} and \{\{end\_time}}; \{\{time}} only groups timestamps into buckets. Overlapping positions cause automatic layout consolidation; the response may include warnings.
>
> #### Input Parameters
>
> **name** `string`
>
> The name of the chart.
>
> **width** `integer`
>
> The width of the chart in grid units. Defaults to 6 when omitted.
>
> **height** `integer`
>
> The height of the chart in grid units. Defaults to 4 when omitted.
>
> **queries** `array` *required*
>
> One or more query objects. Only line\_chart supports multiple queries. Use query\_type sql\_expression with sql\_query, tail\_query with where\_condition, or static\_text with static\_text. source\_variable defaults to source. query\_builder, pql\_expression, and funnel\_query are read-only.
>
> **settings** `object`
>
> A JSON object for chart-specific settings (e.g., units, stacking).
>
> **chart\_type** `string` *required*
>
> The type of chart to create (e.g., `line_chart`, `bar_chart`, `table_chart`).
>
> **description** `string`
>
> A description for the chart.
>
> **dashboard\_id** `integer` *required*
>
> The unique identifier of the dashboard.
>
> **vertical\_position** `integer`
>
> The vertical position of the chart on the dashboard grid (0-based). If omitted, the chart is auto-placed.
>
> **horizontal\_position** `integer`
>
> The horizontal position of the chart on the dashboard grid (0-based). If omitted, the chart is auto-placed.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create chart comment
>
> **Slug:** `BETTER_STACK_CREATE_CHART_COMMENT`
>
> ##### Create a chart comment Pins a comment to a point in time on a chart, the same comment you get by clicking the chart in the Better Stack interface. Use it to mark releases, deployments, and incidents on your charts from your own scripts. POST /api/v2/dashboards/\{dashboard\_id}/charts/\{chart\_id}/comments Requires a Telemetry API token with access to the resource.
>
> #### Input Parameters
>
> **content** `string` *required*
>
> The content of the comment. [Markdown](https://www.markdownguide.org/basic-syntax/) is supported for formatting.
>
> **chart\_id** `integer` *required*
>
> The unique identifier of the chart. Only a line chart can show comments.
>
> **timestamp** `string` *required*
>
> The point on the chart's time axis to pin the comment to, as a datetime such as `2026-08-17T12:34:56.789Z`. A datetime without a zone offset is read as UTC.
>
> **user\_email** `string`
>
> E-mail of a team member to tag in the comment. The mention goes in front of your content, and that team member is notified.
>
> **dashboard\_id** `integer` *required*
>
> The unique identifier of the dashboard.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create collector
>
> **Slug:** `BETTER_STACK_CREATE_COLLECTOR`
>
> ##### Create a collector Creates a new Better Stack collector. \[info] The `platform` and `data_region` attributes can only be set during creation and cannot be updated later. A custom bucket can only be added during creation; its key pair can be rotated with [Update collector](https://betterstack.com/docs/logs/api/update-a-collector/). \[/info] POST /api/v1/collectors Requires a Telemetry API token with access to the resource.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> A unique name for the collector.
>
> **note** `string`
>
> An optional note for the collector.
>
> **platform** `string ("docker" | "swarm" | "kubernetes")` *required*
>
> The platform where the collector will be installed. Valid options are `docker`, `swarm`, and `kubernetes`.
>
> **databases** `array`
>
> An array of database connection objects to be monitored by the collector.
>
> **team\_name** `string`
>
> Required if using a [global API token](https://betterstack.com/docs/logs/api/getting-started/#get-a-global-api-token) to specify the team that will own the collector.
>
> **data\_region** `string`
>
> The data region where the collector's data will be stored. If omitted, the organization's default region is used.
>
> **configuration** `object`
>
> Collector configuration: components (boolean flags), logs\_sample\_rate/traces\_sample\_rate (0-100), vrl\_transformation, disk\_batch\_size\_mb (minimum 256), memory\_batch\_size\_mb, when\_full (drop\_newest or block), log\_line\_length\_limit\_kb (4-128, default 8), services\_options, and namespaces\_options. Omitted components use provider defaults.
>
> **custom\_bucket** `object`
>
> Configuration for [storing data in your own S3-compatible bucket](https://betterstack.com/docs/logs/host-data-in-your-own-bucket/), as an object with the keys below. Nested fields: custom\_bucket.endpoint: The full URL endpoint of the S3-compatible bucket, with no path after the bucket name.  Example: `https://s3.us-east-1.amazonaws.com/storage-bucket`. ; custom\_bucket.access\_key\_id: The access key ID of the key pair that has permissions to access this bucket.; custom\_bucket.secret\_access\_key: The secret access key of the key pair that has permissions to access this bucket.; custom\_bucket.keep\_data\_after\_retention: Whether we should keep data in the bucket after the retention period instead of removing it. Defaults to `false`.
>
> **logs\_retention** `integer`
>
> Custom retention period for logs, in days. This is only available on select plans.
>
> **source\_group\_id** `integer`
>
> The ID of the resource group to assign the collector's associated sources to.
>
> **ingesting\_paused** `boolean`
>
> Set to `true` to create the collector in a paused state, preventing it from ingesting data.
>
> **live\_tail\_pattern** `string`
>
> A custom format for messages displayed in live tail, with columns wrapped in `{column}` brackets.   Example: `"PID: {message_json.pid} {level} {message}"`.   For details, see [Live tail docs](https://betterstack.com/docs/logs/using-logtail/formatting-logs/#live-tail-message-format).
>
> **metrics\_retention** `integer`
>
> Custom retention period for metrics, in days. This is only available on select plans.
>
> **user\_vector\_config** `string`
>
> A custom Vector configuration in YAML format to be merged with the collector's generated configuration.
>
> **source\_vrl\_transformation** `string`
>
> A [VRL program](https://betterstack.com/docs/logs/using-logtail/transforming-ingested-data/logs-vrl/) to be applied to logs server-side during ingestion.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create collector metric target
>
> **Slug:** `BETTER_STACK_CREATE_COLLECTOR_METRIC_TARGET`
>
> ##### Create a collector metric target Creates a new monitoring target on a collector. \[info] Each target kind accepts a specific set of connection fields. Sending a field that does not apply to the chosen kind (for example, `ssl_mode` on a `redis` target) will return a validation error. \[/info] POST /api/v1/collectors/\{collector\_id}/targets Requires a Telemetry API token with access to the resource.
>
> #### Input Parameters
>
> **tls** `string ("false" | "true" | "skip-verify" | "preferred")`
>
> The TLS mode for the connection. Required for `mysql`. Valid options are `false`, `true`, `skip-verify`, and `preferred`.
>
> **host** `string` *required*
>
> The hostname or IP address of the target.
>
> **kind** `string ("postgres" | "mysql" | "redis" | "mongodb" | "memcached" | "elasticsearch" | "nginx" | "apache" | "kafka" | "prometheus")` *required*
>
> The type of target. Valid options are `postgres`, `mysql`, `redis`, `mongodb`, `memcached`, `elasticsearch`, `nginx`, `apache`, `kafka`, and `prometheus`.
>
> **port** `integer`
>
> The port number. Required for database kinds, optional for process kinds.
>
> **scheme** `string ("http" | "https")`
>
> The connection scheme. Only accepted for `elasticsearch`. Valid options are `http` and `https`. Defaults to `http` if omitted.
>
> **api\_key** `string`
>
> An API key for authentication. Only accepted for `elasticsearch`. Write-only - never returned in responses.
>
> **enabled** `boolean`
>
> Set to `false` to create the target in a disabled state. Defaults to `true`.
>
> **service** `string`
>
> The service or container name. Required for `nginx`, `apache`, `kafka`, `prometheus`.
>
> **endpoint** `string`
>
> The full scrape URL, e.g. `http://10.0.0.5:9090/metrics`. Required for `prometheus` targets.
>
> **password** `string`
>
> The password for authentication. Only accepted for databases and `elasticsearch`. Write-only - never returned in responses.
>
> **ssl\_mode** `string ("disable" | "require" | "verify-ca")`
>
> The SSL mode for the connection. Required for `postgres`. Valid options are `disable`, `require`, and `verify-ca`.
>
> **username** `string`
>
> The username for authentication. Only accepted for databases and `elasticsearch`.
>
> **listen\_ip** `string`
>
> The IP address the process listens on. Only accepted for `nginx`, `apache`, and `kafka`.
>
> **collector\_id** `string` *required*
>
> Identifier of the collector.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create connection
>
> **Slug:** `BETTER_STACK_CREATE_CONNECTION`
>
> Create a ClickHouse connection using a global API token, not a team token. The password is returned only in this creation response and cannot be retrieved later. Connections are organization-wide; optionally scope data access with either team\_names or team\_ids, not both. Omit data\_region to create the connection in all regions; private cluster names are also accepted.
>
> #### Input Parameters
>
> **note** `string`
>
> A descriptive note for the connection.
>
> **team\_ids** `array`
>
> Array of team IDs to associate with the connection. Connections are organization-wide, but can be scoped to specific teams for data access control. Only one of `team_names` or `team_ids` should be provided.
>
> **team\_names** `array`
>
> Array of team names to associate with the connection. Connections are organization-wide, but can be scoped to specific teams for data access control. Only one of `team_names` or `team_ids` should be provided.
>
> **client\_type** `string` *required*
>
> Type of client connection. Currently only `clickhouse` is supported.
>
> **data\_region** `string`
>
> Data region or private cluster name to create the connection in.   Permitted values for most plans are: `us_east`, `germany`, `singapore`. Omit to create the connection in all regions.
>
> **valid\_until** `string`
>
> ISO 8601 timestamp when the connection expires.
>
> **ip\_allowlist** `array`
>
> Array of IP addresses or CIDR ranges that are allowed to use this connection.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create dashboard
>
> **Slug:** `BETTER_STACK_CREATE_DASHBOARD`
>
> ##### Create a dashboard Creates a new dashboard, including its variables and other properties. POST /api/v2/dashboards Requires a Telemetry API token with access to the resource.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> The name of the dashboard.
>
> **team\_name** `string`
>
> Required if using a [global API token](https://betterstack.com/docs/logs/api/getting-started/#get-a-global-api-token) to specify which team should own the resource.
>
> **variables** `array`
>
> Custom query variable objects with name, variable\_type, values, default\_values, sql\_definition, and allow\_multiple\_values. sql\_definition is required for select\_with\_sql. allow\_multiple\_values applies to select\_value and select\_with\_sql and defaults to false. Default variables (time, start\_time, end\_time, source) are created automatically if not provided.
>
> **date\_range\_to** `string`
>
> The end of the dashboard's date range.
>
> **date\_range\_from** `string`
>
> The start of the dashboard's date range.
>
> **refresh\_interval** `integer`
>
> Refresh interval in seconds. `0` means no refresh.
>
> **dashboard\_group\_id** `integer`
>
> The ID of a dashboard group to organize this dashboard.
>
> **source\_eligibility\_sql** `string`
>
> An SQL filter determining which sources can be used with this dashboard.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create dashboard alert
>
> **Slug:** `BETTER_STACK_CREATE_DASHBOARD_ALERT`
>
> ##### Create a dashboard alert Creates a new alert for a specific dashboard chart. POST /api/v2/dashboards/\{dashboard\_id}/charts/\{chart\_id}/alerts Requires a Telemetry API token with access to the resource.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Enable SMS notifications. Only used if `escalation_target` is not a policy.
>
> **call** `boolean`
>
> Enable phone call notifications. Only used if `escalation_target` is not a policy.
>
> **name** `string` *required*
>
> The name of the alert.
>
> **push** `boolean`
>
> Enable push notifications. Only used if `escalation_target` is not a policy.
>
> **email** `boolean`
>
> Enable e-mail notifications. Only used if `escalation_target` is not a policy.
>
> **value** `number`
>
> The numeric value for the alert condition. For `threshold` alerts, this is the static threshold. For `relative` alerts, this is the percentage change. Required for `threshold` and `relative` types unless `string_value` is set. A value of `0` is valid.
>
> **paused** `boolean`
>
> Set to `true` to create the alert in a paused state.
>
> **chart\_id** `integer` *required*
>
> The unique identifier of the chart.
>
> **metadata** `object`
>
> A key-value object for custom metadata to be included in incidents. Both keys and values must be strings. For details, see Metadata.
>
> **operator** `string ("equal" | "not_equal" | "higher_than" | "higher_than_or_equal" | "lower_than" | "lower_than_or_equal" | "increases_by" | "decreases_by" | "changes_by")`
>
> The comparison operator. Required for `threshold` and `relative` alerts. For `threshold`: `equal`, `not_equal`, `higher_than`, `higher_than_or_equal`, `lower_than`, `lower_than_or_equal`. For `relative`: `increases_by`, `decreases_by`, `changes_by`. Not used for `anomaly_rrcf` alerts.
>
> **alert\_type** `string ("threshold" | "relative" | "anomaly_rrcf")` *required*
>
> The type of alert. `threshold` for static values, `relative` for percentage changes, or `anomaly_rrcf` for ML-based anomaly detection.
>
> **source\_mode** `string ("source_variable" | "platforms_single_source" | "platforms_all_sources")`
>
> The mode for source selection. Valid values: `source_variable`, `platforms_single_source`, `platforms_all_sources`.
>
> **check\_period** `integer`
>
> How often to evaluate the alert condition, in seconds. Required for `threshold` and `relative` alert types. Not used for `anomaly_rrcf` alerts.
>
> **dashboard\_id** `integer` *required*
>
> The unique identifier of the dashboard.
>
> **query\_period** `integer`
>
> The time window in seconds for the data being analyzed. If not provided, falls back to `aggregation_interval`, then `check_period`.
>
> **series\_names** `array`
>
> An array of strings to filter the alert to specific data series. Cannot be combined with `series_names_except`. Send an empty array to alert on any series.
>
> **string\_value** `string`
>
> An alternative to `value` for `threshold` alerts when matching an exact string. If `string_value` is set, `value` is not required. Only valid with `equal` or `not_equal` operators.
>
> **incident\_name** `string`
>
> A custom name template for the incident created by this alert, in plain text. Supports the same variables as `incident_cause`, such as `{{alert_name}}` and `{{series_name}}`. When empty, the incident is named after the dashboard and the alert.
>
> **critical\_alert** `boolean`
>
> Enable critical push notifications that bypass Do Not Disturb. Only used if `escalation_target` is not a policy.
>
> **incident\_cause** `string`
>
> A custom description template for the incident created by this alert. Supports `{{value}}` placeholder.
>
> **anomaly\_trigger** `string ("any" | "higher" | "lower")`
>
> Defines which anomalies trigger an alert: `any` (both higher and lower), `higher`, or `lower`. Only for `anomaly_rrcf` alerts.
>
> **on\_missing\_data** `string ("treat_as_zero" | "dont_fire" | "treat_as_previous" | "start_incident")`
>
> What to do when the query returns no data: `treat_as_zero`, `dont_fire`, `treat_as_previous`, or `start_incident`. Only for `threshold` and `relative` alerts. Default: `dont_fire`.
>
> **recovery\_period** `integer`
>
> The duration in seconds that a condition must be resolved before an incident is recovered. A value of `0` recovers the incident immediately, `null` means never automatically recover an incident. Default: `60`.
>
> **source\_variable** `string`
>
> The variable name for the source selection. If not provided, derived automatically from the dashboard preset's source variable.
>
> **source\_platforms** `array`
>
> An array of platform names to filter the sources this alert runs on.
>
> **escalation\_target** `string`
>
> Defines where to send notifications. Defaults to `current_team`, for details see Escalation targets.
>
> **anomaly\_sensitivity** `number`
>
> How far the value must deviate from its predicted value to trigger an alert, from `1` to `10`. Higher values require a larger deviation and trigger fewer alerts. Shown as Significance in the app. Only for `anomaly_rrcf` alerts. Default: `5`.
>
> **confirmation\_period** `integer`
>
> The duration in seconds that a condition must be met before an alert is triggered. A value of `0` triggers the alert immediately. Default: `60`.
>
> **incident\_per\_series** `boolean`
>
> Whether a separate incident will be created for each data series that triggers the alert.
>
> **series\_names\_except** `array`
>
> An array of strings to alert on all data series except the listed ones. Cannot be combined with `series_names`.
>
> **aggregation\_interval** `integer`
>
> The size of data buckets in seconds for aggregating and evaluating the metric. If not provided, falls back to `query_period`, then `check_period`.
>
> **additional\_conditions** `array`
>
> An array of up to 4 additional conditions, each combined with the primary condition using logical AND, so the alert only fires where every condition is breached in the same time bucket. Each condition is an object with an `alert_type` of `threshold` or `relative`, an `operator`, a `value` or `string_value`, and an optional `series_names` or `series_names_except` scope. Anomaly detection cannot be used as an additional condition. Send an empty array to clear all additional conditions. See Multiple conditions for an example.
>
> **anomaly\_training\_range\_days** `integer`
>
> How many days of history the anomaly detection model is trained on, from `1` to `30`. Only for `anomaly_rrcf` alerts. Default: `7`.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create dashboard group
>
> **Slug:** `BETTER_STACK_CREATE_DASHBOARD_GROUP`
>
> ##### Create a dashboard group Creates a new dashboard group for organizing dashboards. POST /api/v2/dashboard-groups Requires a Telemetry API token with access to the resource.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> The name of the dashboard group.
>
> **team\_name** `string`
>
> Required if using a [global API token](https://betterstack.com/docs/logs/api/getting-started/#get-a-global-api-token) to specify which team should own the resource.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create dashboard section
>
> **Slug:** `BETTER_STACK_CREATE_DASHBOARD_SECTION`
>
> ##### Create a dashboard section Creates a new section on a specific dashboard. POST /api/v2/dashboards/\{dashboard\_id}/sections Requires a Telemetry API token with access to the resource.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> The name of the section.
>
> **collapsed** `boolean`
>
> Whether the section should be collapsed by default. Defaults to false at the provider when omitted.
>
> **explanation** `string`
>
> The explanation text shown for the section.
>
> **dashboard\_id** `integer` *required*
>
> The unique identifier of the dashboard.
>
> **vertical\_position** `integer`
>
> The vertical position of the section on the dashboard grid. If omitted, it's placed below all existing items.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Datadog integration
>
> **Slug:** `BETTER_STACK_CREATE_DATADOG_INTEGRATION`
>
> ##### Create Datadog integration Returns either a newly created Datadog integration, or validation errors. POST /api/v2/datadog-integrations Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Send an SMS to the on-call person.
>
> **call** `boolean`
>
> Call the on-call person.
>
> **name** `string`
>
> The name of the Datadog integration that you can see in the dashboard.
>
> **push** `boolean`
>
> Send a push notification to the on-call person.
>
> **email** `boolean`
>
> Send an e-mail to the on-call person.
>
> **paused** `boolean`
>
> Set to `true` to pause the integration, `false` to unpause it.
>
> **policy\_id** `string`
>
> ID of the escalation policy associated with the Datadog integration.
>
> **team\_name** `string`
>
> Required if using [global API token](https://betterstack.com/docs/uptime/api/getting-started-with-uptime-api/#get-a-global-api-token) to specify the team which should own the resource
>
> **team\_wait** `integer`
>
> How long we wait before escalating the incident alert to the team. In seconds.
>
> **alerting\_rule** `string ("alert" | "alert_and_warn")`
>
> Should we alert only on alarms, or on both alarms and warnings. Possible values: `alert`, `alert_and_warn`. Defaults to `alert`.
>
> **critical\_alert** `boolean`
>
> Send a critical push notification that ignores the mute switch and Do not Disturb mode.
>
> **recovery\_period** `integer`
>
> Has no effect for this integration, since an incident resolves as soon as Datadog reports the alert as resolved.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Elastic integration
>
> **Slug:** `BETTER_STACK_CREATE_ELASTIC_INTEGRATION`
>
> ##### Create Elastic integration Returns either a newly created Elastic integration, or validation errors. POST /api/v2/elastic-integrations Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Send an SMS to the on-call person.
>
> **call** `boolean`
>
> Call the on-call person.
>
> **name** `string`
>
> The name of the Elastic integration that you can see in the dashboard.
>
> **push** `boolean`
>
> Send a push notification to the on-call person.
>
> **email** `boolean`
>
> Send an e-mail to the on-call person.
>
> **paused** `boolean`
>
> Set to `true` to pause the integration, `false` to unpause it.
>
> **policy\_id** `string`
>
> ID of the escalation policy associated with the Elastic integration.
>
> **team\_name** `string`
>
> Required if using [global API token](https://betterstack.com/docs/uptime/api/getting-started-with-uptime-api/#get-a-global-api-token) to specify the team which should own the resource
>
> **team\_wait** `integer`
>
> How long we wait before escalating the incident alert to the team. In seconds.
>
> **critical\_alert** `boolean`
>
> Send a critical push notification that ignores the mute switch and Do not Disturb mode.
>
> **recovery\_period** `integer`
>
> Has no effect for this integration, since an incident resolves as soon as Elastic reports the alert as resolved.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create email integration
>
> **Slug:** `BETTER_STACK_CREATE_EMAIL_INTEGRATION`
>
> ##### Create e-mail integration Returns either a newly created e-mail integration, or validation errors. POST /api/v2/email-integrations Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Send an SMS to the on-call person.
>
> **call** `boolean`
>
> Call the on-call person.
>
> **name** `string`
>
> The name of the e-mail integration that you can see in the dashboard.
>
> **push** `boolean`
>
> Send a push notification to the on-call person.
>
> **email** `boolean`
>
> Send an e-mail to the on-call person.
>
> **paused** `boolean`
>
> Set to `true` to pause the integration, `false` to unpause it.
>
> **policy\_id** `string`
>
> ID of the escalation policy for incidents from this integration. Without one, incidents alert the current on-call person through the channels set by `call`, `sms`, `email`, and `push`.
>
> **team\_name** `string`
>
> Required if using [global API token](https://betterstack.com/docs/uptime/api/getting-started-with-uptime-api/#get-a-global-api-token) to specify the team which should own the resource
>
> **team\_wait** `integer`
>
> How long we wait before escalating the incident to the team. In seconds. Send `null` to never escalate to the team, or `0` to alert the whole team right away.
>
> **cause\_field** `object`
>
> How to extract the incident cause from the e-mail that starts an incident, as a field object with the keys below. Defaults to the whole subject. Nested fields: cause\_field.field\_target: Which part of the e-mail to read: `from_email`, `subject`, or `body`.; cause\_field.match\_type: What to extract: `match_everything` takes the whole value, `match_before` the text before `content`, `match_after` the text after `content`, `match_between` the text between `content_before` and `content_after`, and `match_regex` the match of the regular expression in `content`, or its capture group.; cause\_field.content: The text to extract around for `match_before` and `match_after`, or the regular expression for `match_regex`. Required for those three.; cause\_field.content\_before: Where extraction starts for `match_between`. Required for `match_between`.; cause\_field.content\_after: Where extraction stops for `match_between`. Leave it empty to extract to the end.
>
> **title\_field** `object`
>
> How to extract a custom incident title, as a field object with the same keys as `cause_field`. Send `null` to remove it and use the default title.
>
> **started\_rules** `array`
>
> The conditions `started_rule_type` checks, as an array of rule objects with the keys below. At least one rule is required when the type is `any` or `all`. Nested fields: started\_rules\[].rule\_target: Which part of the e-mail the rule checks: `from_email`, `subject`, or `body`.; started\_rules\[].match\_type: How to compare the value with `content`: `contains`, `contains_not`, `equals`, `equals_not`, `matches_regex`, or `matches_regex_not`.; started\_rules\[].content: The value to compare with. Must be a valid regular expression for `matches_regex` and `matches_regex_not`.
>
> **critical\_alert** `boolean`
>
> Send a critical push notification that ignores the mute switch and Do Not Disturb mode.
>
> **resolved\_rules** `array`
>
> The conditions `resolved_rule_type` checks, as rule objects with the same keys as `started_rules`.
>
> **recovery\_period** `integer`
>
> How long to wait after an e-mail matching `resolved_rules` arrives before marking an incident as resolved, in seconds: `0`, `60`, `180`, `300`, `900`, `1800`, `3600`, or `7200`. Has no effect while `resolved_rule_type` is `unused`.
>
> **started\_rule\_type** `string ("unused" | "any" | "all")`
>
> When e-mails start an incident: `unused` always, `any` when at least one of `started_rules` matches, or `all` when all of them match. Defaults to `unused`.
>
> **acknowledged\_rules** `array`
>
> The conditions `acknowledged_rule_type` checks, as rule objects with the same keys as `started_rules`.
>
> **resolved\_rule\_type** `string ("unused" | "any" | "all")`
>
> When e-mails resolve an incident: `unused` never, `any` when at least one of `resolved_rules` matches, or `all` when all of them match. Defaults to `unused`, and any other value requires `started_alert_id_field` and `resolved_alert_id_field`.
>
> **other\_started\_fields** `array`
>
> Extra values to extract when an incident starts, saved as incident metadata. Each field object has the same keys as `cause_field`, plus `name`. Nested fields: other\_started\_fields\[].name: The metadata key to save the extracted value under. Must be unique within the array.
>
> **other\_resolved\_fields** `array`
>
> Extra values to extract when an incident is resolved, with the same keys as `other_started_fields`.
>
> **acknowledged\_rule\_type** `string ("unused" | "any" | "all")`
>
> When e-mails acknowledge an incident: `unused` never, `any` when at least one of `acknowledged_rules` matches, or `all` when all of them match. Defaults to `unused`, and any other value requires `started_alert_id_field` and `acknowledged_alert_id_field`.
>
> **started\_alert\_id\_field** `object`
>
> How to extract the alert ID from the e-mail that starts an incident, with the same keys as `cause_field`; later e-mails acknowledge and resolve the incident by matching it. Required when `acknowledged_rule_type` or `resolved_rule_type` isn't `unused`.
>
> **resolved\_alert\_id\_field** `object`
>
> How to extract the alert ID from an e-mail that resolves an incident, with the same keys as `cause_field`. Required when `resolved_rule_type` isn't `unused`.
>
> **other\_acknowledged\_fields** `array`
>
> Extra values to extract when an incident is acknowledged, with the same keys as `other_started_fields`.
>
> **acknowledged\_alert\_id\_field** `object`
>
> How to extract the alert ID from an e-mail that acknowledges an incident, with the same keys as `cause_field`. Required when `acknowledged_rule_type` isn't `unused`.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Escalation Policy
>
> **Slug:** `BETTER_STACK_CREATE_ESCALATION_POLICY`
>
> Creates a new escalation policy for incident management. Escalation policies define who gets notified and in what order when incidents occur. Supports multiple step types: 'escalation' (notify members), 'instructions' (guidance text), 'time\_branching' (route by schedule), and 'metadata\_branching' (route by incident metadata). For escalation steps, a valid urgency\_id from the Severities API is required.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> Name of the escalation policy
>
> **steps** `array` *required*
>
> Ordered list of escalation policy steps
>
> **team\_name** `string`
>
> Team owning the policy (required with global API token)
>
> **repeat\_count** `integer`
>
> How many times to repeat the policy if unacknowledged
>
> **repeat\_delay** `integer`
>
> Seconds to wait between policy repetitions
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create exploration
>
> **Slug:** `BETTER_STACK_CREATE_EXPLORATION`
>
> ##### Create an exploration Creates a new exploration, including its chart, queries, and variables. POST /api/v2/explorations Requires a Telemetry API token with access to the resource.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> The name of the exploration. This is also set as the chart's name.
>
> **chart** `object` *required*
>
> An object defining the chart's type and settings. `chart_type` is required.
>
> **queries** `array` *required*
>
> One or more query objects. Only line\_chart supports multiple queries. query\_type must be sql\_expression (requires sql\_query), tail\_query (requires where\_condition), or static\_text (requires static\_text), compatible with chart\_type. query\_builder, pql\_expression and funnel\_query are read-only and cannot be created.
>
> **team\_name** `string`
>
> Required if using a [global API token](https://betterstack.com/docs/logs/api/getting-started/#get-a-global-api-token) to specify which team should own the resource.
>
> **variables** `array`
>
> An array of custom query variable objects. Default variables (`time`, `start_time`, `end_time`, `source`) are created automatically if not provided.
>
> **date\_range\_to** `string`
>
> The end of the exploration's date range. Defaults to now when omitted.
>
> **date\_range\_from** `string`
>
> The start of the exploration's date range. Defaults to now-3h when omitted.
>
> **exploration\_group\_id** `integer`
>
> The ID of an exploration group to organize this exploration. Use `0` to remove it from a group.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create exploration alert
>
> **Slug:** `BETTER_STACK_CREATE_EXPLORATION_ALERT`
>
> ##### Create an exploration alert Creates a new alert for a specific exploration. POST /api/v2/explorations/\{exploration\_id}/alerts Requires a Telemetry API token with access to the resource.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Enable SMS notifications. Only used if `escalation_target` is not a policy.
>
> **call** `boolean`
>
> Enable phone call notifications. Only used if `escalation_target` is not a policy.
>
> **name** `string` *required*
>
> The name of the alert.
>
> **push** `boolean`
>
> Enable push notifications. Only used if `escalation_target` is not a policy.
>
> **email** `boolean`
>
> Enable e-mail notifications. Only used if `escalation_target` is not a policy.
>
> **value** `number`
>
> The numeric value for the alert condition. For `threshold` alerts, this is the static threshold. For `relative` alerts, this is the percentage change. Required for `threshold` and `relative` types unless `string_value` is set. A value of `0` is valid.
>
> **paused** `boolean`
>
> Set to `true` to create the alert in a paused state.
>
> **metadata** `object`
>
> A key-value object for custom metadata to be included in incidents. Both keys and values must be strings. For details, see Metadata.
>
> **operator** `string ("equal" | "not_equal" | "higher_than" | "higher_than_or_equal" | "lower_than" | "lower_than_or_equal" | "increases_by" | "decreases_by" | "changes_by")`
>
> The comparison operator. Required for `threshold` and `relative` alerts. For `threshold`: `equal`, `not_equal`, `higher_than`, `higher_than_or_equal`, `lower_than`, `lower_than_or_equal`. For `relative`: `increases_by`, `decreases_by`, `changes_by`. Not used for `anomaly_rrcf` alerts.
>
> **alert\_type** `string ("threshold" | "relative" | "anomaly_rrcf")` *required*
>
> The type of alert. `threshold` for static values, `relative` for percentage changes, and `anomaly_rrcf` for ML-based anomaly detection.
>
> **source\_mode** `string ("source_variable" | "platforms_single_source" | "platforms_all_sources")`
>
> The mode for source selection. Valid values: `source_variable`, `platforms_single_source`, `platforms_all_sources`.
>
> **check\_period** `integer`
>
> How often to evaluate the alert condition, in seconds. Required for `threshold` and `relative` alert types. Not used for `anomaly_rrcf` alerts.
>
> **query\_period** `integer`
>
> The time window in seconds for the data being analyzed. If not provided, falls back to `aggregation_interval`, then `check_period`.
>
> **series\_names** `array`
>
> An array of strings to filter the alert to specific data series. Cannot be combined with `series_names_except`. Send an empty array to alert on any series.
>
> **string\_value** `string`
>
> An alternative to `value` for `threshold` alerts when matching an exact string. If `string_value` is set, `value` is not required. Only valid with `equal` or `not_equal` operators.
>
> **incident\_name** `string`
>
> A custom name template for the incident created by this alert, in plain text. Supports the same variables as `incident_cause`, such as `{{alert_name}}` and `{{series_name}}`. When empty, the incident is named after the exploration and the alert.
>
> **critical\_alert** `boolean`
>
> Enable critical push notifications that bypass Do Not Disturb. Only used if `escalation_target` is not a policy.
>
> **exploration\_id** `integer` *required*
>
> The unique identifier of the exploration to add the alert to.
>
> **incident\_cause** `string`
>
> A custom description template for the incident created by this alert. Supports `{{value}}` placeholder.
>
> **anomaly\_trigger** `string ("any" | "higher" | "lower")`
>
> Defines which anomalies trigger an alert: `any` (both higher and lower), `higher`, or `lower`. Only for `anomaly_rrcf` alerts.
>
> **on\_missing\_data** `string ("treat_as_zero" | "dont_fire" | "treat_as_previous" | "start_incident")`
>
> What to do when the query returns no data: `treat_as_zero`, `dont_fire`, `treat_as_previous`, or `start_incident`. Only for `threshold` and `relative` alerts. Default: `dont_fire`.
>
> **recovery\_period** `integer`
>
> The duration in seconds that a condition must be resolved before an incident is recovered. A value of `0` recovers the incident immediately, `null` means never automatically recover an incident. Default: `60`.
>
> **source\_variable** `string`
>
> The variable name for the source selection. If not provided, derived automatically from the exploration preset's source variable.
>
> **source\_platforms** `array`
>
> An array of platform names to filter the sources this alert runs on.
>
> **escalation\_target** `string`
>
> Defines where to send notifications. Defaults to `current_team`, for details see Escalation targets.
>
> **anomaly\_sensitivity** `number`
>
> How far the value must deviate from its predicted value to trigger an alert, from `1` to `10`. Higher values require a larger deviation and trigger fewer alerts. Shown as Significance in the app. Only for `anomaly_rrcf` alerts. Default: `5`.
>
> **confirmation\_period** `integer`
>
> The duration in seconds that a condition must be met before an alert is triggered. A value of `0` triggers the alert immediately. Default: `60`.
>
> **incident\_per\_series** `boolean`
>
> Whether a separate incident will be created for each data series that triggers the alert.
>
> **series\_names\_except** `array`
>
> An array of strings to alert on all data series except the listed ones. Cannot be combined with `series_names`.
>
> **aggregation\_interval** `integer`
>
> The size of data buckets in seconds for aggregating and evaluating the metric. If not provided, falls back to `query_period`, then `check_period`.
>
> **additional\_conditions** `array`
>
> An array of up to 4 additional conditions, each combined with the primary condition using logical AND, so the alert only fires where every condition is breached in the same time bucket. Each condition is an object with an `alert_type` of `threshold` or `relative`, an `operator`, a `value` or `string_value`, and an optional `series_names` or `series_names_except` scope. Anomaly detection cannot be used as an additional condition. Send an empty array to clear all additional conditions. See Multiple conditions for an example.
>
> **anomaly\_training\_range\_days** `integer`
>
> How many days of history the anomaly detection model is trained on, from `1` to `30`. Only for `anomaly_rrcf` alerts. Default: `7`.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create exploration group
>
> **Slug:** `BETTER_STACK_CREATE_EXPLORATION_GROUP`
>
> ##### Create an exploration group Creates a new exploration group for organizing explorations. POST /api/v2/exploration-groups Requires a Telemetry API token with access to the resource.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> The name of the exploration group.
>
> **team\_name** `string`
>
> Required if using a [global API token](https://betterstack.com/docs/logs/api/getting-started/#get-a-global-api-token) to specify which team should own the resource.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Google Monitoring integration
>
> **Slug:** `BETTER_STACK_CREATE_GOOGLE_MONITORING_INTEGRATION`
>
> ##### Create Google Monitoring integration Returns either a newly created Google Monitoring integration, or validation errors. POST /api/v2/google-monitoring-integrations Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Send an SMS to the on-call person.
>
> **call** `boolean`
>
> Call the on-call person.
>
> **name** `string`
>
> The name of the Google Monitoring integration that you can see in the dashboard.
>
> **push** `boolean`
>
> Send a push notification to the on-call person.
>
> **email** `boolean`
>
> Send an e-mail to the on-call person.
>
> **paused** `boolean`
>
> Set to `true` to pause the integration, `false` to unpause it.
>
> **policy\_id** `string`
>
> ID of the escalation policy associated with the Google Monitoring integration.
>
> **team\_name** `string`
>
> Required if using [global API token](https://betterstack.com/docs/uptime/api/getting-started-with-uptime-api/#get-a-global-api-token) to specify the team which should own the resource
>
> **team\_wait** `integer`
>
> How long we wait before escalating the incident alert to the team. In seconds.
>
> **critical\_alert** `boolean`
>
> Send a critical push notification that ignores the mute switch and Do not Disturb mode.
>
> **recovery\_period** `integer`
>
> Has no effect for this integration, since an incident resolves as soon as Google Monitoring reports the alert as resolved.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Grafana integration
>
> **Slug:** `BETTER_STACK_CREATE_GRAFANA_INTEGRATION`
>
> ##### Create Grafana integration Returns either a newly created Grafana integration, or validation errors. POST /api/v2/grafana-integrations Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Send an SMS to the on-call person.
>
> **call** `boolean`
>
> Call the on-call person.
>
> **name** `string`
>
> The name of the Grafana integration that you can see in the dashboard.
>
> **push** `boolean`
>
> Send a push notification to the on-call person.
>
> **email** `boolean`
>
> Send an e-mail to the on-call person.
>
> **paused** `boolean`
>
> Set to `true` to pause the integration, `false` to unpause it.
>
> **policy\_id** `string`
>
> ID of the escalation policy associated with the Grafana integration.
>
> **team\_name** `string`
>
> Required if using [global API token](https://betterstack.com/docs/uptime/api/getting-started-with-uptime-api/#get-a-global-api-token) to specify the team which should own the resource
>
> **team\_wait** `integer`
>
> How long we wait before escalating the incident alert to the team. In seconds.
>
> **critical\_alert** `boolean`
>
> Send a critical push notification that ignores the mute switch and Do not Disturb mode.
>
> **recovery\_period** `integer`
>
> Has no effect for this integration, since an incident resolves as soon as Grafana reports the alert as resolved.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Heartbeat
>
> **Slug:** `BETTER_STACK_CREATE_HEARTBEAT`
>
> Tool to create a new heartbeat monitor for cron jobs and scheduled tasks. Use when you need to set up monitoring for a service that should send regular heartbeat signals.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Should we send an SMS to the on-call person?
>
> **call** `boolean`
>
> Should we call the on-call person?
>
> **name** `string`
>
> The name of the service for this heartbeat
>
> **push** `boolean`
>
> Should we send a push notification to the on-call person?
>
> **email** `boolean`
>
> Should we send an email to the on-call person?
>
> **grace** `integer`
>
> Grace period for heartbeat fluctuation in seconds. Minimum value: 0. Recommended: 20% of period
>
> **paused** `boolean`
>
> Set to true to pause monitoring
>
> **period** `integer`
>
> How often should we expect this heartbeat in seconds. Minimum value: 30 seconds
>
> **team\_name** `string`
>
> Required if using global API token to specify the team which should own the resource
>
> **heartbeat\_group\_id** `integer`
>
> Set this attribute to add this heartbeat to a heartbeat group
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Heartbeat Group
>
> **Slug:** `BETTER_STACK_CREATE_HEARTBEAT_GROUP`
>
> Tool to create a new heartbeat group. Use when you need to organize related heartbeat checks under a single, logical group. Example prompt: "Create a new heartbeat group named 'Backend services'."
>
> #### Input Parameters
>
> **name** `string` *required*
>
> Name of the group visible in the dashboard.
>
> **paused** `boolean`
>
> Set to true to pause monitoring for all existing heartbeats in the group; false (default) to resume monitoring.
>
> **team\_name** `string`
>
> Team which should own the resource. Required when using a global API token.
>
> **sort\_index** `integer`
>
> Zero-based index to control sort order of heartbeat groups.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Incident
>
> **Slug:** `BETTER_STACK_CREATE_INCIDENT`
>
> Tool to create a new incident and alert the on-call person. Use when you need to manually report an incident or trigger escalation workflows. The incident will be routed according to the specified escalation policy or default team settings.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Send SMS notification to on-call person
>
> **call** `boolean`
>
> Trigger phone call to on-call person
>
> **name** `string`
>
> Short incident title
>
> **email** `boolean`
>
> Send email notification to on-call person
>
> **summary** `string`
>
> Brief incident overview
>
> **metadata** `object`
>
> Custom metadata with key-value pairs for incident classification and routing
>
> **policy\_id** `string`
>
> Escalation policy identifier for routing the incident
>
> **team\_name** `string`
>
> Team owning the incident (required when using global API token)
>
> **team\_wait** `integer`
>
> Escalation delay in seconds before alerting entire team. Leave blank to disable team escalation.
>
> **description** `string`
>
> Detailed incident information
>
> **critical\_alert** `boolean`
>
> Send critical push notification that ignores mute switch and Do Not Disturb settings
>
> **requester\_email** `string`
>
> Email of user requesting the incident
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Incident Comment
>
> **Slug:** `BETTER_STACK_CREATE_INCIDENT_COMMENT`
>
> Tool to create a new comment on an incident. Use when you need to add documentation, updates, or notes to an existing incident in Better Stack.
>
> #### Input Parameters
>
> **content** `string` *required*
>
> The content of the comment. Markdown is supported for formatting.
>
> **incident\_id** `string` *required*
>
> The ID of the incident to add the comment to
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create incoming webhook
>
> **Slug:** `BETTER_STACK_CREATE_INCOMING_WEBHOOK`
>
> ##### Create incoming webhook Returns either a newly created incoming webhook, or validation errors. POST /api/v2/incoming-webhooks Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Send an SMS to the on-call person.
>
> **call** `boolean`
>
> Call the on-call person.
>
> **name** `string`
>
> The name of the incoming webhook that you can see in the dashboard.
>
> **push** `boolean`
>
> Send a push notification to the on-call person.
>
> **email** `boolean`
>
> Send an e-mail to the on-call person.
>
> **paused** `boolean`
>
> Set to `true` to pause the integration, `false` to unpause it.
>
> **policy\_id** `string`
>
> ID of the escalation policy for incidents from this integration. Without one, incidents alert the current on-call person through the channels set by `call`, `sms`, `email`, and `push`.
>
> **team\_name** `string`
>
> Required if using [global API token](https://betterstack.com/docs/uptime/api/getting-started-with-uptime-api/#get-a-global-api-token) to specify the team which should own the resource
>
> **team\_wait** `integer`
>
> How long we wait before escalating the incident to the team. In seconds. Send `null` to never escalate to the team, or `0` to alert the whole team right away.
>
> **cause\_field** `object`
>
> Incident cause extraction object; omitted means Unknown cause. Required string keys: field\_target (query\_string, header, body, json, xml) and match\_type (match\_everything, match\_before, match\_after, match\_between, match\_regex). target\_field: dot path such as alert.id for json/query\_string, header name for header, or CSS selector for xml; unused for body. match\_everything takes the whole value. match\_before/match\_after require string content and extract text before/after it. match\_regex requires a regex in content and extracts its match or capture group. match\_between requires string content\_before and content\_after delimiters.
>
> **title\_field** `object`
>
> How to extract a custom incident title, as a field object with the same keys as `cause_field`. Send `null` to remove it and use the default title.
>
> **started\_rules** `array`
>
> The conditions `started_rule_type` checks, as an array of rule objects with the keys below. At least one rule is required when the type is `any` or `all`. Nested fields: started\_rules\[].rule\_target: Which part of the request the rule checks: `query_string`, `header`, `body`, `json`, or `xml`.; started\_rules\[].target\_field: Which value to read: a dot-separated path such as `alert.id` for `json` and `query_string`, a header name for `header`, or a CSS selector for `xml`. Not used with `body`.; started\_rules\[].match\_type: How to compare the value with `content`: `contains`, `contains_not`, `equals`, `equals_not`, `matches_regex`, or `matches_regex_not`.; started\_rules\[].content: The value to compare with. Must be a valid regular expression for `matches_regex` and `matches_regex_not`.
>
> **critical\_alert** `boolean`
>
> Send a critical push notification that ignores the mute switch and Do Not Disturb mode.
>
> **resolved\_rules** `array`
>
> The conditions `resolved_rule_type` checks, as rule objects with the same keys as `started_rules`.
>
> **recovery\_period** `integer ("0" | "60" | "180" | "300" | "900" | "1800" | "3600" | "7200")`
>
> How long to wait after a request matching `resolved_rules` arrives before marking an incident as resolved, in seconds: `0`, `60`, `180`, `300`, `900`, `1800`, `3600`, or `7200`. Has no effect while `resolved_rule_type` is `unused`.
>
> **started\_rule\_type** `string ("unused" | "any" | "all")`
>
> When requests start an incident: `unused` always, `any` when at least one of `started_rules` matches, or `all` when all of them match. Defaults to `unused`.
>
> **acknowledged\_rules** `array`
>
> The conditions `acknowledged_rule_type` checks, as rule objects with the same keys as `started_rules`.
>
> **resolved\_rule\_type** `string ("unused" | "any" | "all")`
>
> When requests resolve an incident: `unused` never, `any` when at least one of `resolved_rules` matches, or `all` when all of them match. Defaults to `unused`, and any other value requires `started_alert_id_field` and `resolved_alert_id_field`.
>
> **other\_started\_fields** `array`
>
> Extra values to extract when an incident starts, saved as incident metadata. Each field object has the same keys as `cause_field`, plus `name`. Nested fields: other\_started\_fields\[].name: The metadata key to save the extracted value under. Must be unique within the array.
>
> **other\_resolved\_fields** `array`
>
> Extra values to extract when an incident is resolved, with the same keys as `other_started_fields`.
>
> **acknowledged\_rule\_type** `string ("unused" | "any" | "all")`
>
> When requests acknowledge an incident: `unused` never, `any` when at least one of `acknowledged_rules` matches, or `all` when all of them match. Defaults to `unused`, and any other value requires `started_alert_id_field` and `acknowledged_alert_id_field`.
>
> **started\_alert\_id\_field** `object`
>
> How to extract the alert ID from the request that starts an incident, with the same keys as `cause_field`; later requests acknowledge and resolve the incident by matching it. Required when `acknowledged_rule_type` or `resolved_rule_type` isn't `unused`.
>
> **resolved\_alert\_id\_field** `object`
>
> How to extract the alert ID from a request that resolves an incident, with the same keys as `cause_field`. Required when `resolved_rule_type` isn't `unused`.
>
> **other\_acknowledged\_fields** `array`
>
> Extra values to extract when an incident is acknowledged, with the same keys as `other_started_fields`.
>
> **acknowledged\_alert\_id\_field** `object`
>
> How to extract the alert ID from a request that acknowledges an incident, with the same keys as `cause_field`. Required when `acknowledged_rule_type` isn't `unused`.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Metadata
>
> **Slug:** `BETTER_STACK_CREATE_METADATA`
>
> Tool to create or update a metadata record for a resource. Metadata provides key-value associations for resources like monitors, heartbeats, or incidents. Use when you need to tag or annotate resources with custom data. Existing values for the specified key will be completely replaced.
>
> #### Input Parameters
>
> **key** `string` *required*
>
> The metadata key identifier. This serves as the name for the metadata entry
>
> **values** `array` *required*
>
> Array of metadata values to associate with the key. Existing values for the given key will be completely replaced
>
> **owner\_id** `string` *required*
>
> The ID of the resource to update metadata for
>
> **owner\_type** `string ("Monitor" | "Heartbeat" | "Incident" | "WebhookIntegration" | "EmailIntegration" | "IncomingWebhook" | "CallRouting")` *required*
>
> Type of resource that owns this metadata. Must be one of: Monitor, Heartbeat, Incident, WebhookIntegration, EmailIntegration, IncomingWebhook, or CallRouting
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create metric
>
> **Slug:** `BETTER_STACK_CREATE_METRIC`
>
> ##### Create a metric Returns a newly created metric or label. POST /api/v2/sources/\{source\_id}/metrics Requires a Telemetry API token with access to the resource.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> Metric name
>
> **source\_id** `integer` *required*
>
> Source for which to create a metric
>
> **team\_name** `string`
>
> Required if using [global API token](https://betterstack.com/docs/logs/api/getting-started/#get-a-global-api-token) to specify the team which should own the resource
>
> **aggregations** `array`
>
> Aggregations to apply to the metric. Omit or send an empty array to create a label instead. Valid aggregations are `avg`, `count`, `uniq`, `max`, `min`, `sum`, and `histogram`.
>
> **sql\_expression** `string` *required*
>
> SQL expression to use for the metric
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Monitor
>
> **Slug:** `BETTER_STACK_CREATE_MONITOR`
>
> Tool to create a new uptime monitor for a URL or service. Use when you need to set up monitoring for websites, APIs, servers, or network services. Supports multiple monitor types including HTTP/HTTPS status checks, keyword monitoring, ping, TCP/UDP, email protocols, DNS queries, and browser automation with Playwright.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Enable SMS notifications when monitor goes down or recovers. Default is false.
>
> **url** `string` *required*
>
> The URL or host to monitor. For HTTP/HTTPS monitors use full URL with protocol. For TCP/UDP/SMTP/POP/IMAP use hostname or IP. For DNS monitors use the domain to query.
>
> **call** `boolean`
>
> Enable phone call alerts when monitor goes down or recovers. Default is false.
>
> **port** `string`
>
> Port number for TCP, UDP, SMTP, POP, or IMAP monitors. Required for these monitor types.
>
> **push** `boolean`
>
> Enable push notifications when monitor goes down or recovers. Default is false.
>
> **email** `boolean`
>
> Enable email notifications when monitor goes down or recovers. Default is false.
>
> **paused** `boolean`
>
> If true, the monitor is created in paused state and will not perform checks. Default is false.
>
> **regions** `array`
>
> List of regions from which to perform checks. Available: us (United States), eu (Europe), as (Asia), au (Australia). Default is all regions.
>
> **policy\_id** `string`
>
> ID of the escalation policy to use for this monitor. Controls who gets notified and in what order.
>
> **team\_name** `string`
>
> Team which should own this monitor. Required when using a global API token.
>
> **team\_wait** `integer`
>
> Seconds to wait before escalating to the team after first notification. Default is 0 (notify team immediately).
>
> **verify\_ssl** `boolean`
>
> Verify SSL certificates for HTTPS monitors. If false, monitors will accept invalid/self-signed certificates. Default is true.
>
> **http\_method** `string ("GET" | "HEAD" | "POST" | "PUT" | "PATCH")`
>
> HTTP method for status/keyword monitors.
>
> **monitor\_type** `string ("status" | "expected_status_code" | "keyword" | "keyword_absence" | "ping" | "tcp" | "udp" | "smtp" | "pop" | "imap" | "dns" | "playwright")` *required*
>
> Type of monitor: status (HTTP/HTTPS), expected\_status\_code, keyword, keyword\_absence, ping (ICMP), tcp, udp, smtp, pop, imap, dns, or playwright (browser automation).
>
> **request\_body** `string`
>
> Body content to send with POST/PUT/PATCH requests. Required for DNS monitors (specify the DNS record type to query).
>
> **auth\_password** `string`
>
> Password for HTTP Basic Authentication. Used with auth\_username.
>
> **auth\_username** `string`
>
> Username for HTTP Basic Authentication. Used with auth\_password.
>
> **scenario\_name** `string`
>
> Name identifier for playwright monitor scenarios. Used to distinguish between different automation scripts.
>
> **critical\_alert** `boolean`
>
> If enabled, alerts will override Do Not Disturb settings and mute schedules. Use for critical monitors only.
>
> **maintenance\_to** `string`
>
> End time of daily maintenance window in HH:MM:SS format. Checks resume after this time.
>
> **check\_frequency** `integer`
>
> How often to check the monitor in seconds. Minimum is 30 seconds. Default is 30.
>
> **recovery\_period** `integer`
>
> Number of seconds the monitor must be up before automatically resolving any open incidents. Default is 0 (resolve immediately).
>
> **request\_timeout** `integer`
>
> Request timeout in seconds. For server monitors this is in milliseconds. Default varies by monitor type.
>
> **follow\_redirects** `boolean`
>
> Automatically follow HTTP redirects when checking status/keyword monitors. Default is false.
>
> **maintenance\_days** `array`
>
> Days of the week to skip monitoring checks during maintenance windows. Combine with maintenance\_from and maintenance\_to.
>
> **maintenance\_from** `string`
>
> Start time of daily maintenance window in HH:MM:SS format. Checks are skipped during this window on specified maintenance\_days.
>
> **monitor\_group\_id** `string`
>
> ID of the monitor group to assign this monitor to. Used for organizing monitors.
>
> **required\_keyword** `string`
>
> For keyword monitors: the text that must be present in the response. For keyword\_absence monitors: the text that must NOT be present.
>
> **playwright\_script** `string`
>
> JavaScript code for playwright monitor type. Defines browser automation scenario to execute during checks.
>
> **pronounceable\_name** `string` *required*
>
> Human-readable name for the monitor displayed in the dashboard.
>
> **confirmation\_period** `integer`
>
> How long in seconds to observe failures before creating an incident. Helps avoid false alerts from transient issues. Default is 0.
>
> **expiration\_policy\_id** `integer`
>
> ID of the escalation policy for SSL certificate and domain expiration alerts.
>
> **maintenance\_timezone** `string`
>
> Timezone for maintenance window times. Use IANA timezone database names.
>
> **environment\_variables** `object`
>
> Key-value pairs of environment variables accessible within playwright scripts. Useful for parameterizing automation scenarios.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Monitor Group
>
> **Slug:** `BETTER_STACK_CREATE_MONITOR_GROUP`
>
> Tool to create a new monitor group. Use when you need to organize related monitors under a single, logical group for better dashboard organization.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> The display name for the monitor group visible in the dashboard
>
> **paused** `boolean`
>
> When true, monitoring pauses for existing group monitors; false resumes monitoring
>
> **team\_name** `string`
>
> Required only when using a global API token to specify resource ownership
>
> **sort\_index** `integer`
>
> Numeric value controlling monitor group sort order
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create New Relic integration
>
> **Slug:** `BETTER_STACK_CREATE_NEW_RELIC_INTEGRATION`
>
> ##### Create New Relic integration Returns either a newly created New Relic integration, or validation errors. POST /api/v2/new-relic-integrations Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **sms** `boolean`
>
> Send an SMS to the on-call person.
>
> **call** `boolean`
>
> Call the on-call person.
>
> **name** `string`
>
> The name of the New Relic integration that you can see in the dashboard.
>
> **push** `boolean`
>
> Send a push notification to the on-call person.
>
> **email** `boolean`
>
> Send an e-mail to the on-call person.
>
> **paused** `boolean`
>
> Set to `true` to pause the integration, `false` to unpause it.
>
> **policy\_id** `string`
>
> ID of the escalation policy associated with the New Relic integration.
>
> **team\_name** `string`
>
> Required if using [global API token](https://betterstack.com/docs/uptime/api/getting-started-with-uptime-api/#get-a-global-api-token) to specify the team which should own the resource
>
> **team\_wait** `integer`
>
> How long we wait before escalating the incident alert to the team. In seconds.
>
> **alerting\_rule** `string ("alert" | "alert_and_warn")`
>
> Should we alert only on alarms, or on both alarms and warnings. Possible values: `alert`, `alert_and_warn`. Defaults to `alert`.
>
> **critical\_alert** `boolean`
>
> Send a critical push notification that ignores the mute switch and Do not Disturb mode.
>
> **recovery\_period** `integer`
>
> Has no effect for this integration, since an incident resolves as soon as New Relic reports the alert as resolved.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create on-call event
>
> **Slug:** `BETTER_STACK_CREATE_ON_CALL_EVENT`
>
> ##### Create an on-call schedule event Create a new event in the given on-call schedule. POST /api/v2/on-calls/\{schedule\_id}/events Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **users** `array` *required*
>
> List of e-mail addresses of users that will be on-call during this event. Each user must be a member of the schedule's team with a role that can respond to incidents, such as Responder.
>
> **ends\_at** `string` *required*
>
> End time of the event as an ISO 8601 date-time.
>
> **override** `boolean`
>
> Whether this event is an override. Override events take precedence over regular scheduled events. Defaults to `false`.
>
> **starts\_at** `string` *required*
>
> Start time of the event as an ISO 8601 date-time. Must be today at 0:00 UTC or later.
>
> **schedule\_id** `string` *required*
>
> The ID of the on-call schedule you want to create the event for. Use `default` to refer to the default on-call schedule for the team.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create On-Call Schedule
>
> **Slug:** `BETTER_STACK_CREATE_ON_CALL_SCHEDULE`
>
> Tool to create a new on-call schedule. Use when you need to set up a new on-call calendar for managing team rotations.
>
> #### Input Parameters
>
> **name** `string` *required*
>
> The identifier for the on-call schedule
>
> **team\_name** `string`
>
> Team which should own the resource. Required when using a global API token.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create outgoing email
>
> **Slug:** `BETTER_STACK_CREATE_OUTGOING_EMAIL`
>
> ##### Create outgoing e-mail Returns either a newly created outgoing e-mail integration, or validation errors. See the [outgoing e-mails guide](https://betterstack.com/docs/uptime/integrations/integrating-with-better-uptime/outgoing-emails/) for the dashboard walkthrough. POST /api/v2/outgoing-emails Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **name** `string`
>
> The name of the outgoing e-mail integration that you can see in the dashboard.
>
> **team\_name** `string`
>
> Required if using a [global API token](https://betterstack.com/docs/uptime/api/getting-started-with-uptime-api/#get-a-global-api-token) to specify the team which should own the resource.
>
> **templates** `array`
>
> Per-event template objects with incident\_stage (started, acknowledged, resolved, reopened, comment) and optional subject, title, body strings. Empty fields use default copy. Supports \$NAME, \$STATUS, \$CAUSE, \$INCIDENT\_URL, \$RECIPIENT.\<key>, \$METADATA.Key and \$METADATA\_ARRAY. Example: \[\{"incident\_stage":"started","subject":"Incident: \$NAME"}]. Included stages are created/updated; omitted stages are removed. Omit templates entirely to leave existing templates untouched.
>
> **recipients** `array` *required*
>
> The addresses that receive incident e-mails. At least one recipient is required. Each entry is either a plain e-mail string, or an object with an `email` key plus your own custom attribute keys, which you can insert into templates with `$RECIPIENT.<key>`.  `json [label Plain strings and objects can be mixed] {   "recipients": [     "noc@client.com",     { "email": "ops@client.com", "first_name": "Sam", "team": "SRE" }   ] } `
>
> **on\_incident\_comment** `boolean`
>
> Whether to send an e-mail when a new comment is added to an incident. Defaults to `true`. At least one of the `on_incident_*` triggers must be enabled.
>
> **on\_incident\_started** `boolean`
>
> Whether to send an e-mail when an incident starts. Defaults to `true`.
>
> **on\_incident\_reopened** `boolean`
>
> Whether to send an e-mail when an incident is reopened. Defaults to `true`.
>
> **on\_incident\_resolved** `boolean`
>
> Whether to send an e-mail when an incident is resolved. Defaults to `true`.
>
> **on\_incident\_acknowledged** `boolean`
>
> Whether to send an e-mail when an incident is acknowledged. Defaults to `true`.
>
> **notify\_alongside\_primary\_responder** `boolean`
>
> Whether to notify recipients alongside the primary responder when no escalation policy is configured. Defaults to `true`.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Outgoing Webhook Integration
>
> **Slug:** `BETTER_STACK_CREATE_OUTGOING_WEBHOOK`
>
> Tool to create a new outgoing webhook integration. Use when you need to register an endpoint to receive event notifications from Better Stack.
>
> #### Input Parameters
>
> **url** `string` *required*
>
> The endpoint URL of the outgoing webhook integration.
>
> **name** `string` *required*
>
> The name of the outgoing webhook integration.
>
> **team\_name** `string`
>
> Required if using a global API token to specify the team which should own the resource.
>
> **trigger\_type** `string ("on_call_change" | "incident_change" | "monitor_change")` *required*
>
> The type of event that triggers the webhook.
>
> **on\_incident\_started** `boolean`
>
> Trigger when an incident starts (only if trigger\_type is 'incident\_change').
>
> **on\_incident\_resolved** `boolean`
>
> Trigger when an incident is resolved (only if trigger\_type is 'incident\_change').
>
> **on\_incident\_acknowledged** `boolean`
>
> Trigger when an incident is acknowledged (only if trigger\_type is 'incident\_change').
>
> **custom\_webhook\_template\_attributes** `object`
>
> Custom webhook template attributes such as HTTP method, headers, and body.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create PagerDuty integration
>
> **Slug:** `BETTER_STACK_CREATE_PAGERDUTY_INTEGRATION`
>
> ##### Create PagerDuty integration Returns either a newly created PagerDuty integration, or validation errors. POST /api/v2/pager-duty-webhooks Requires a Better Stack Incidents API token with access to the resource.
>
> #### Input Parameters
>
> **key** `string` *required*
>
> The PagerDuty routing key.
>
> **name** `string` *required*
>
> The name of the PagerDuty integration that you can see in the dashboard.
>
> **severity** `string ("info" | "warning" | "error" | "critical")` *required*
>
> The severity of PagerDuty alerts created for new incidents.
>
> **team\_name** `string`
>
> Required if using [global API token](https://betterstack.com/docs/uptime/api/getting-started-with-uptime-api/#get-a-global-api-token) to specify the team which should own the resource
>
> **notify\_alongside\_primary\_responder** `boolean`
>
> Whether to notify this integration alongside the primary responder when no escalation policy is configured. Defaults to `true`.
>
> #### Output
>
> **data** `string` *required*
>
> Data from the action execution
>
> **error** `string`
>
> Error if any occurred during the execution of the action
>
> **successful** `boolean` *required*
>
> Whether or not the action execution was successful or not

> [accordion] Create Escalation Policy Group
>
> **Slug:** `BETTER_STACK_CREATE_POLICY_GROUP`
>
> Tool to create a new escalation policy group. Use when you need to organize related escalation policies under a single logical group.
>
> #### Input Parameters
>
[...]
